/*
   Ride The BB2.mq4 |
   jamrdavi18 |
   https://www.mql5.com |
*/
#property copyright "jamrdavi18"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

//Calling the Framework
#include <Orchard/Framework/Framework_2.03/Framework.mqh>



input double LotSize = 0.02;
input double BBDeviation = 2;
input int BBPeriod = 20;
input ENUM_APPLIED_PRICE BBAppliedTo = PRICE_CLOSE;
input int BBMethod = 0;
input int BBShift = 0;
input int ATRPeriod = 10;
input int RSIPeriod = 9;
input int RSIUpper = 70;
input int RSILower = 30;
input ENUM_APPLIED_PRICE RSIAppliedTo = PRICE_CLOSE;
input int SlowMAPeriod = 45;
input ENUM_APPLIED_PRICE SlowMAAppliedTo = PRICE_CLOSE;
input ENUM_MA_METHOD SlowMAMethod = 0;
input int SlowMAShift = 0;
input int MagicNumber = 3838;
   double UpperBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_UPPER,1);
   double LowerBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_LOWER,1);
   double MiddleBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_MAIN,1);

double pips;


int OnInit()
  {
  double stopsLevel;
  stopsLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);

   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
  {
  }

void OnTick()
  {
   if(!IsNewBar()) return;
  
   double close1 = iClose(Symbol(), Period(),1);
   double open = iOpen(Symbol(), Period(),0);
   double hihg1 = iHigh(Symbol(), Period(),1);
   double low1 = iLow(Symbol(), Period(),1);
   
   double RSI = iRSI(Symbol(),Period(),RSIPeriod,RSIAppliedTo,0);
   double SlowMA = iMA(Symbol(),Period(),SlowMAPeriod,SlowMAShift,SlowMAMethod,SlowMAAppliedTo,0);
   double ATR = iATR(Symbol(),Period(),ATRPeriod, 0);
   
   double currUpperBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_UPPER,0);
   double currLowerBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_LOWER,0);
   double currMiddleBB=iBands(Symbol(),Period(),BBPeriod,BBDeviation,BBShift,BBAppliedTo,MODE_MAIN,0);
     
      if(close1==open && close1>=UpperBB && SlowMA<=MiddleBB && RSI<=RSIUpper && currUpperBB-UpperBB>=0.00010)
      {
         BuyOrder(ORDER_TYPE_BUY,open);
      }   
      else if(close1==open && close1<=LowerBB && SlowMA>=MiddleBB && RSI>=RSILower && LowerBB-currLowerBB>=0.00010)
      {
         SellOrder(ORDER_TYPE_SELL,open);
      }

   return;
   }  
   
  bool IsNewBar()
  {
      datetime currentBarTime = iTime(Symbol(),Period(),0);
      static datetime prevBarTime = currentBarTime;
  
         if(prevBarTime < currentBarTime)
            {
               prevBarTime = currentBarTime;
               return(true);
            }
  
      return(false);
  
  }

  int BuyOrder(ENUM_ORDER_TYPE orderType,double entryPrice)
  {
      double ATR = iATR(Symbol(),Period(),ATRPeriod,1);
      
      double sl;
      double tp;
      
      entryPrice = NormalizeDouble(entryPrice, Digits());
      double tpBuy = 0;
      double slBuy = 0;
      double price = 0;
  
      double stopsLevel = Point()*SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL);
      
         if(orderType%2==ORDER_TYPE_BUY)
            {
               price = Ask;
               tp = ATR*4;
               sl = Bid-ATR*2;

                  if(price>(entryPrice-stopsLevel))
                     {
                        entryPrice = price;
                        orderType = ORDER_TYPE_BUY;
                     }
  
               tpBuy = NormalizeDouble(entryPrice+tp,Digits());
               slBuy = NormalizeDouble(entryPrice-sl,Digits());

            }
 
       else
         {
            return(0);
         }
   return(OrderSend(Symbol(),orderType,LotSize,entryPrice,4,slBuy,tpBuy,NULL,MagicNumber,0));
   
  }

  int SellOrder(ENUM_ORDER_TYPE orderType,double entryPrice)
  {
      double ATR = iATR(Symbol(),Period(),ATRPeriod, 1);

      double tp;
      double sl;
  
      entryPrice = NormalizeDouble(entryPrice, Digits());
      double tpSell = 0;
      double slSell = 0;
      double price = 0;
  
      double stopsLevel = Point()*SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL);
  
         if(orderType%2==ORDER_TYPE_SELL)
            {
               price = Bid;
               tp = ATR*4;
               sl = Ask+ATR*2;
                  if(price<(entryPrice+stopsLevel))
                     {
                        entryPrice = price;
                        orderType = ORDER_TYPE_SELL;
                     }
  
               tpSell = NormalizeDouble(entryPrice-tp,Digits());
               slSell = NormalizeDouble(entryPrice+sl,Digits());
            }
  
       else
         {
            return(0);
         }
   return(OrderSend(Symbol(),orderType,LotSize,entryPrice,4,slSell,tpSell,NULL,MagicNumber,0));
   
  }
